/* -*- C++ -*-
 *
 * <<< pico_base.h >>>
 *
 * --- pico base class 'pico_base' - for custom pico processor(s)
 *     Copyright (C) 1995-2001 Amano Lab., Keio University. ---
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 */

#ifndef PICO_BASE_H
#define PICO_BASE_H 1

#include <isis/processor.h>
#include "pico_typedef.h"


class pico_base : public processor<pico_word>
{
private:
	typedef pico_base thisclass;
	typedef processor<pico_word> inherited;
public:
	typedef inherited::address_type address_type;
	typedef inherited::data_type data_type;
	static const size_t sizeof_data_type = sizeof_pico_word;
public:
};

#endif /* PICO_BASE_H */
