
sub b2h{
	my($binary) = shift;
    my(%TRANS);
	my($rem,$pos,$num,$sub);
    my($break,$result);
	%TRANS = ( '0000' => '0', '0001' => '1',
               '0010' => '2', '0011' => '3',
               '0100' => '4', '0101' => '5',
               '0110' => '6', '0111' => '7',
               '1000' => '8', '1001' => '9',
               '1010' => 'a', '1011' => 'b',
               '1100' => 'c', '1101' => 'd',
               '1110' => 'e', '1111' => 'f' );

    $break = 4;
	$rem = length $binary;
    $pos = 0;
	$result = "";
 
	while($rem){
		$num = $rem > $break ? $break : $rem;
		$pos -= $num;
		$sub = substr($binary,$pos,$num);
		$sub = '0' x ($break-$num) . $sub if $break != $num;
		$result = $TRANS{$sub} . $result;
        $rem -= $num;
	}
	return $result;
}
 
sub d2b{
	my($decimal, $bit) = @_;
    my($flag, $mask);
    my($result);

    $result = "";
	$flag = $decimal >= 0 ? '0' : '1';
	$decimal = ~abs($decimal) + 1 if $decimal < 0;
    $mask = 1;

    while($decimal){
       $result = ($decimal & $mask) . $result;
       $decimal >>= 1;
    }

	if(defined $bit){
		if($bit < length $result){
			$mask = 0 - $bit;
			$result = substr($result, $mask, $bit);
		} else {
			$mask = $bit - length $result;
			$result = ($flag x $mask) . $result;
		}
	}
    return $result;
}

sub h2b{
	my($hex, $bit) = @_;
    my($pos, $char);
    my(%TRANS);
    my($result);
	%TRANS = ( '0' => '0000', '1' => '0001',
	           '2' => '0010', '3' => '0011',
	           '4' => '0100', '5' => '0101',
	           '6' => '0110', '7' => '0111',
	           '8' => '1000', '9' => '1001',
	           'a' => '1010', 'b' => '1011',
	           'c' => '1100', 'd' => '1101',
	           'e' => '1110', 'f' => '1111' );

    $result = "";
	$hex =~ tr/[A-F]/[a-f]/;
	($hex) = ($hex =~ m/^0x([0-9a-f]+)$/);
    $pos = length $hex - 1;

    while($pos >= 0){
       $char = substr($hex, $pos, 1);
       $result = $TRANS{$char} . $result;
		$pos--;
    }

	if(defined $bit){
		if($bit < length $result){
			$pos = 0 - $bit;
			$result = substr($result,$pos,$bit);
		} else {
			$pos = $bit - length $result;
			$result = substr($result,0,1) x $pos . $result;
		}
	}
    return $result;
}


sub b2d(){
	my($bitstring) = shift;
	my($pos, $retval);

#	print "$bitstring >>\n"; #debug
	while($pos){
#		print "$pos : ",substr($bitstring, -$pos, 1),"\n"; #debug
		$retval <<= 1;
		$retval += substr($bitstring, -$pos, 1);
		$pos--;
	}

	return $retval;	
}

1;

